// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(
	columns, table,
	whereClause interface{}, distinctClause interface{},
	count interface{}, groupByClause interface{}, orderList interface{},
	offsetClause interface{},
) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
		Table:       table.(parsers.Table),
	}

	switch v := whereClause.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression, parsers.Constant, parsers.SelectItem:
		selectStmt.Filters = v
	}

	if distinctClause != nil {
		selectStmt.Distinct = true
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if offsetArr, ok := offsetClause.([]interface{}); ok && len(offsetArr) == 2 {
		if n, ok := offsetArr[0].(int); ok {
			selectStmt.Offset = n
		}

		if n, ok := offsetArr[1].(int); ok {
			selectStmt.Count = n
		}
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	if groupByClause != nil {
		selectStmt.GroupBy = groupByClause.([]parsers.SelectItem)
	}

	return selectStmt, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 158, col: 1, offset: 4186},
			expr: &actionExpr{
				pos: position{line: 158, col: 10, offset: 4195},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 158, col: 10, offset: 4195},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 158, col: 21, offset: 4206},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 162, col: 1, offset: 4249},
			expr: &actionExpr{
				pos: position{line: 162, col: 15, offset: 4263},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 162, col: 15, offset: 4263},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 162, col: 15, offset: 4263},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 162, col: 22, offset: 4270},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 163, col: 5, offset: 4277},
							label: "distinctClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 163, col: 20, offset: 4292},
								expr: &ruleRefExpr{
									pos:  position{line: 163, col: 20, offset: 4292},
									name: "DistinctClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 163, col: 36, offset: 4308},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 164, col: 5, offset: 4315},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 164, col: 15, offset: 4325},
								expr: &ruleRefExpr{
									pos:  position{line: 164, col: 15, offset: 4325},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 164, col: 26, offset: 4336},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 164, col: 29, offset: 4339},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 164, col: 37, offset: 4347},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 164, col: 47, offset: 4357},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 165, col: 5, offset: 4364},
							name: "From",
						},
						&ruleRefExpr{
							pos:  position{line: 165, col: 10, offset: 4369},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 165, col: 13, offset: 4372},
							label: "table",
							expr: &ruleRefExpr{
								pos:  position{line: 165, col: 19, offset: 4378},
								name: "TableName",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 165, col: 29, offset: 4388},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 166, col: 5, offset: 4395},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 166, col: 17, offset: 4407},
								expr: &actionExpr{
									pos: position{line: 166, col: 18, offset: 4408},
									run: (*parser).callonSelectStmt23,
									expr: &seqExpr{
										pos: position{line: 166, col: 18, offset: 4408},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 166, col: 18, offset: 4408},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 166, col: 21, offset: 4411},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 166, col: 27, offset: 4417},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 166, col: 30, offset: 4420},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 166, col: 40, offset: 4430},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 167, col: 5, offset: 4472},
							label: "groupByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 167, col: 19, offset: 4486},
								expr: &actionExpr{
									pos: position{line: 167, col: 20, offset: 4487},
									run: (*parser).callonSelectStmt32,
									expr: &seqExpr{
										pos: position{line: 167, col: 20, offset: 4487},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 167, col: 20, offset: 4487},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 167, col: 23, offset: 4490},
												name: "GroupBy",
											},
											&ruleRefExpr{
												pos:  position{line: 167, col: 31, offset: 4498},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 167, col: 34, offset: 4501},
												label: "columns",
												expr: &ruleRefExpr{
													pos:  position{line: 167, col: 42, offset: 4509},
													name: "ColumnList",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 168, col: 5, offset: 4550},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 168, col: 19, offset: 4564},
								expr: &ruleRefExpr{
									pos:  position{line: 168, col: 19, offset: 4564},
									name: "OrderByClause",
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 169, col: 5, offset: 4583},
							label: "offsetClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 169, col: 18, offset: 4596},
								expr: &ruleRefExpr{
									pos:  position{line: 169, col: 18, offset: 4596},
									name: "OffsetClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DistinctClause",
			pos:  position{line: 174, col: 1, offset: 4749},
			expr: &litMatcher{
				pos:        position{line: 174, col: 19, offset: 4767},
				val:        "distinct",
				ignoreCase: true,
				want:       "\"DISTINCT\"i",
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 176, col: 1, offset: 4780},
			expr: &actionExpr{
				pos: position{line: 176, col: 14, offset: 4793},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 176, col: 14, offset: 4793},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 176, col: 14, offset: 4793},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 176, col: 18, offset: 4797},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 176, col: 21, offset: 4800},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 176, col: 27, offset: 4806},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "OffsetClause",
			pos:  position{line: 180, col: 1, offset: 4841},
			expr: &actionExpr{
				pos: position{line: 180, col: 17, offset: 4857},
				run: (*parser).callonOffsetClause1,
				expr: &seqExpr{
					pos: position{line: 180, col: 17, offset: 4857},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 180, col: 17, offset: 4857},
							val:        "offset",
							ignoreCase: true,
							want:       "\"OFFSET\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 180, col: 27, offset: 4867},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 180, col: 30, offset: 4870},
							label: "offset",
							expr: &ruleRefExpr{
								pos:  position{line: 180, col: 37, offset: 4877},
								name: "IntegerLiteral",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 180, col: 52, offset: 4892},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 180, col: 55, offset: 4895},
							val:        "limit",
							ignoreCase: true,
							want:       "\"LIMIT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 180, col: 64, offset: 4904},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 180, col: 67, offset: 4907},
							label: "limit",
							expr: &ruleRefExpr{
								pos:  position{line: 180, col: 73, offset: 4913},
								name: "IntegerLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 184, col: 1, offset: 5028},
			expr: &choiceExpr{
				pos: position{line: 184, col: 14, offset: 5041},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 184, col: 14, offset: 5041},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 184, col: 32, offset: 5059},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 184, col: 45, offset: 5072},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 186, col: 1, offset: 5088},
			expr: &actionExpr{
				pos: position{line: 186, col: 19, offset: 5106},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 186, col: 19, offset: 5106},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 192, col: 1, offset: 5301},
			expr: &actionExpr{
				pos: position{line: 192, col: 15, offset: 5315},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 192, col: 15, offset: 5315},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 192, col: 15, offset: 5315},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 192, col: 22, offset: 5322},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 192, col: 33, offset: 5333},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 192, col: 47, offset: 5347},
								expr: &actionExpr{
									pos: position{line: 192, col: 48, offset: 5348},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 192, col: 48, offset: 5348},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 192, col: 48, offset: 5348},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 192, col: 51, offset: 5351},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 192, col: 55, offset: 5355},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 192, col: 58, offset: 5358},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 192, col: 63, offset: 5363},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 196, col: 1, offset: 5450},
			expr: &actionExpr{
				pos: position{line: 196, col: 20, offset: 5469},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 196, col: 20, offset: 5469},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 196, col: 20, offset: 5469},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 196, col: 29, offset: 5478},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 196, col: 32, offset: 5481},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 196, col: 39, offset: 5488},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 202, col: 1, offset: 5642},
			expr: &actionExpr{
				pos: position{line: 202, col: 14, offset: 5655},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 202, col: 14, offset: 5655},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 202, col: 18, offset: 5659},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 206, col: 1, offset: 5726},
			expr: &actionExpr{
				pos: position{line: 206, col: 16, offset: 5741},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 206, col: 16, offset: 5741},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 206, col: 16, offset: 5741},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 206, col: 20, offset: 5745},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 206, col: 23, offset: 5748},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 206, col: 31, offset: 5756},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 206, col: 42, offset: 5767},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 206, col: 45, offset: 5770},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 210, col: 1, offset: 5815},
			expr: &actionExpr{
				pos: position{line: 210, col: 17, offset: 5831},
				run: (*parser).callonSelectObject1,
				expr: &seqExpr{
					pos: position{line: 210, col: 17, offset: 5831},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 210, col: 17, offset: 5831},
							val:        "{",
							ignoreCase: false,
							want:       "\"{\"",
						},
						&ruleRefExpr{
							pos:  position{line: 210, col: 21, offset: 5835},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 210, col: 24, offset: 5838},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 210, col: 30, offset: 5844},
								name: "SelectObjectField",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 210, col: 48, offset: 5862},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 210, col: 51, offset: 5865},
							label: "other_fields",
							expr: &zeroOrMoreExpr{
								pos: position{line: 210, col: 64, offset: 5878},
								expr: &actionExpr{
									pos: position{line: 210, col: 65, offset: 5879},
									run: (*parser).callonSelectObject10,
									expr: &seqExpr{
										pos: position{line: 210, col: 65, offset: 5879},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 210, col: 65, offset: 5879},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 210, col: 68, offset: 5882},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 210, col: 72, offset: 5886},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 210, col: 75, offset: 5889},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 210, col: 80, offset: 5894},
													name: "SelectObjectField",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 210, col: 120, offset: 5934},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 210, col: 123, offset: 5937},
							val:        "}",
							ignoreCase: false,
							want:       "\"}\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 214, col: 1, offset: 5995},
			expr: &actionExpr{
				pos: position{line: 214, col: 22, offset: 6016},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 214, col: 22, offset: 6016},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 214, col: 22, offset: 6016},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 214, col: 28, offset: 6022},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 214, col: 28, offset: 6022},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 214, col: 41, offset: 6035},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 214, col: 41, offset: 6035},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 214, col: 41, offset: 6035},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 214, col: 46, offset: 6040},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 214, col: 50, offset: 6044},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 214, col: 61, offset: 6055},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 214, col: 87, offset: 6081},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 214, col: 90, offset: 6084},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 214, col: 94, offset: 6088},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 214, col: 97, offset: 6091},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 214, col: 108, offset: 6102},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 220, col: 1, offset: 6208},
			expr: &actionExpr{
				pos: position{line: 220, col: 19, offset: 6226},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 220, col: 19, offset: 6226},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 220, col: 19, offset: 6226},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 220, col: 24, offset: 6231},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 220, col: 35, offset: 6242},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 220, col: 40, offset: 6247},
								expr: &choiceExpr{
									pos: position{line: 220, col: 41, offset: 6248},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 220, col: 41, offset: 6248},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 220, col: 58, offset: 6265},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 224, col: 1, offset: 6356},
			expr: &actionExpr{
				pos: position{line: 224, col: 15, offset: 6370},
				run: (*parser).callonSelectItem1,
				expr: &seqExpr{
					pos: position{line: 224, col: 15, offset: 6370},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 224, col: 15, offset: 6370},
							label: "selectItem",
							expr: &choiceExpr{
								pos: position{line: 224, col: 27, offset: 6382},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 224, col: 27, offset: 6382},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 224, col: 37, offset: 6392},
										name: "FunctionCall",
									},
									&ruleRefExpr{
										pos:  position{line: 224, col: 52, offset: 6407},
										name: "SelectArray",
									},
									&ruleRefExpr{
										pos:  position{line: 224, col: 66, offset: 6421},
										name: "SelectObject",
									},
									&ruleRefExpr{
										pos:  position{line: 224, col: 81, offset: 6436},
										name: "SelectProperty",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 224, col: 97, offset: 6452},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 224, col: 106, offset: 6461},
								expr: &ruleRefExpr{
									pos:  position{line: 224, col: 106, offset: 6461},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 248, col: 1, offset: 7059},
			expr: &actionExpr{
				pos: position{line: 248, col: 13, offset: 7071},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 248, col: 13, offset: 7071},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 248, col: 13, offset: 7071},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 248, col: 16, offset: 7074},
							name: "As",
						},
						&ruleRefExpr{
							pos:  position{line: 248, col: 19, offset: 7077},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 248, col: 22, offset: 7080},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 248, col: 28, offset: 7086},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 250, col: 1, offset: 7120},
			expr: &actionExpr{
				pos: position{line: 250, col: 19, offset: 7138},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 250, col: 19, offset: 7138},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 250, col: 19, offset: 7138},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 250, col: 23, offset: 7142},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 250, col: 26, offset: 7145},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 254, col: 1, offset: 7180},
			expr: &choiceExpr{
				pos: position{line: 254, col: 21, offset: 7200},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 254, col: 21, offset: 7200},
						run: (*parser).callonArrayFieldAccess2,
						expr: &seqExpr{
							pos: position{line: 254, col: 21, offset: 7200},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 254, col: 21, offset: 7200},
									val:        "[\"",
									ignoreCase: false,
									want:       "\"[\\\"\"",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 27, offset: 7206},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 30, offset: 7209},
										name: "Identifier",
									},
								},
								&litMatcher{
									pos:        position{line: 254, col: 41, offset: 7220},
									val:        "\"]",
									ignoreCase: false,
									want:       "\"\\\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 255, col: 5, offset: 7249},
						run: (*parser).callonArrayFieldAccess8,
						expr: &seqExpr{
							pos: position{line: 255, col: 5, offset: 7249},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 255, col: 5, offset: 7249},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 255, col: 9, offset: 7253},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 255, col: 12, offset: 7256},
										name: "Integer",
									},
								},
								&litMatcher{
									pos:        position{line: 255, col: 20, offset: 7264},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 257, col: 1, offset: 7308},
			expr: &actionExpr{
				pos: position{line: 257, col: 15, offset: 7322},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 257, col: 15, offset: 7322},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 257, col: 15, offset: 7322},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 257, col: 24, offset: 7331},
							expr: &charClassMatcher{
								pos:        position{line: 257, col: 24, offset: 7331},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 261, col: 1, offset: 7381},
			expr: &actionExpr{
				pos: position{line: 261, col: 14, offset: 7394},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 261, col: 14, offset: 7394},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 261, col: 25, offset: 7405},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 265, col: 1, offset: 7450},
			expr: &actionExpr{
				pos: position{line: 265, col: 17, offset: 7466},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 265, col: 17, offset: 7466},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 265, col: 17, offset: 7466},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 265, col: 21, offset: 7470},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 265, col: 35, offset: 7484},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 265, col: 39, offset: 7488},
								expr: &actionExpr{
									pos: position{line: 265, col: 40, offset: 7489},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 265, col: 40, offset: 7489},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 265, col: 40, offset: 7489},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 265, col: 43, offset: 7492},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 265, col: 46, offset: 7495},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 265, col: 49, offset: 7498},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 265, col: 52, offset: 7501},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 269, col: 1, offset: 7614},
			expr: &actionExpr{
				pos: position{line: 269, col: 18, offset: 7631},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 269, col: 18, offset: 7631},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 269, col: 18, offset: 7631},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 269, col: 22, offset: 7635},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 269, col: 43, offset: 7656},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 269, col: 47, offset: 7660},
								expr: &actionExpr{
									pos: position{line: 269, col: 48, offset: 7661},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 269, col: 48, offset: 7661},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 269, col: 48, offset: 7661},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 269, col: 51, offset: 7664},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 269, col: 55, offset: 7668},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 269, col: 58, offset: 7671},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 269, col: 61, offset: 7674},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 273, col: 1, offset: 7795},
			expr: &choiceExpr{
				pos: position{line: 273, col: 25, offset: 7819},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 273, col: 25, offset: 7819},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 273, col: 25, offset: 7819},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 273, col: 25, offset: 7819},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 273, col: 29, offset: 7823},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 273, col: 32, offset: 7826},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 273, col: 35, offset: 7829},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 273, col: 48, offset: 7842},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 273, col: 51, offset: 7845},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 274, col: 7, offset: 7874},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 274, col: 7, offset: 7874},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 274, col: 7, offset: 7874},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 274, col: 12, offset: 7879},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 274, col: 23, offset: 7890},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 274, col: 26, offset: 7893},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 274, col: 29, offset: 7896},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 274, col: 48, offset: 7915},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 274, col: 51, offset: 7918},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 274, col: 57, offset: 7924},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 276, col: 5, offset: 8031},
						run: (*parser).callonComparisonExpression20,
						expr: &labeledExpr{
							pos:   position{line: 276, col: 5, offset: 8031},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 276, col: 8, offset: 8034},
								name: "BooleanLiteral",
							},
						},
					},
					&actionExpr{
						pos: position{line: 277, col: 5, offset: 8072},
						run: (*parser).callonComparisonExpression23,
						expr: &labeledExpr{
							pos:   position{line: 277, col: 5, offset: 8072},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 277, col: 8, offset: 8075},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 279, col: 1, offset: 8106},
			expr: &actionExpr{
				pos: position{line: 279, col: 18, offset: 8123},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 279, col: 18, offset: 8123},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 279, col: 18, offset: 8123},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 279, col: 26, offset: 8131},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 279, col: 29, offset: 8134},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 279, col: 33, offset: 8138},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 279, col: 49, offset: 8154},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 279, col: 56, offset: 8161},
								expr: &actionExpr{
									pos: position{line: 279, col: 57, offset: 8162},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 279, col: 57, offset: 8162},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 279, col: 57, offset: 8162},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 279, col: 60, offset: 8165},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 279, col: 64, offset: 8169},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 279, col: 67, offset: 8172},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 279, col: 70, offset: 8175},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 283, col: 1, offset: 8259},
			expr: &actionExpr{
				pos: position{line: 283, col: 20, offset: 8278},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 283, col: 20, offset: 8278},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 283, col: 20, offset: 8278},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 283, col: 26, offset: 8284},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 283, col: 41, offset: 8299},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 283, col: 44, offset: 8302},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 283, col: 50, offset: 8308},
								expr: &ruleRefExpr{
									pos:  position{line: 283, col: 50, offset: 8308},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 287, col: 1, offset: 8374},
			expr: &actionExpr{
				pos: position{line: 287, col: 19, offset: 8392},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 287, col: 20, offset: 8393},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 287, col: 20, offset: 8393},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 287, col: 29, offset: 8402},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 295, col: 1, offset: 8554},
			expr: &litMatcher{
				pos:        position{line: 295, col: 11, offset: 8564},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 297, col: 1, offset: 8575},
			expr: &litMatcher{
				pos:        position{line: 297, col: 8, offset: 8582},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 299, col: 1, offset: 8590},
			expr: &litMatcher{
				pos:        position{line: 299, col: 7, offset: 8596},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 301, col: 1, offset: 8603},
			expr: &litMatcher{
				pos:        position{line: 301, col: 9, offset: 8611},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 303, col: 1, offset: 8620},
			expr: &litMatcher{
				pos:        position{line: 303, col: 10, offset: 8629},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 305, col: 1, offset: 8639},
			expr: &litMatcher{
				pos:        position{line: 305, col: 8, offset: 8646},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 307, col: 1, offset: 8654},
			expr: &litMatcher{
				pos:        position{line: 307, col: 7, offset: 8660},
				val:        "or",
				ignoreCase: true,
				want:       "\"OR\"i",
			},
		},
		{
			name: "GroupBy",
			pos:  position{line: 309, col: 1, offset: 8667},
			expr: &seqExpr{
				pos: position{line: 309, col: 12, offset: 8678},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 309, col: 12, offset: 8678},
						val:        "group",
						ignoreCase: true,
						want:       "\"GROUP\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 309, col: 21, offset: 8687},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 309, col: 24, offset: 8690},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 311, col: 1, offset: 8697},
			expr: &seqExpr{
				pos: position{line: 311, col: 12, offset: 8708},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 311, col: 12, offset: 8708},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 311, col: 21, offset: 8717},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 311, col: 24, offset: 8720},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 313, col: 1, offset: 8727},
			expr: &actionExpr{
				pos: position{line: 313, col: 23, offset: 8749},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 313, col: 24, offset: 8750},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 313, col: 24, offset: 8750},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 313, col: 30, offset: 8756},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 313, col: 37, offset: 8763},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 313, col: 43, offset: 8769},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 313, col: 50, offset: 8776},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
						&litMatcher{
							pos:        position{line: 313, col: 56, offset: 8782},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 317, col: 1, offset: 8824},
			expr: &choiceExpr{
				pos: position{line: 317, col: 12, offset: 8835},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 317, col: 12, offset: 8835},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 317, col: 27, offset: 8850},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 317, col: 44, offset: 8867},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 317, col: 60, offset: 8883},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 317, col: 77, offset: 8900},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 317, col: 97, offset: 8920},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 319, col: 1, offset: 8934},
			expr: &actionExpr{
				pos: position{line: 319, col: 22, offset: 8955},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 319, col: 22, offset: 8955},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 319, col: 22, offset: 8955},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 319, col: 26, offset: 8959},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 322, col: 1, offset: 9075},
			expr: &actionExpr{
				pos: position{line: 322, col: 17, offset: 9091},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 322, col: 17, offset: 9091},
					val:        "null",
					ignoreCase: true,
					want:       "\"null\"i",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 326, col: 1, offset: 9149},
			expr: &actionExpr{
				pos: position{line: 326, col: 19, offset: 9167},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 326, col: 19, offset: 9167},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 326, col: 26, offset: 9174},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 329, col: 1, offset: 9275},
			expr: &actionExpr{
				pos: position{line: 329, col: 18, offset: 9292},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 329, col: 18, offset: 9292},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 329, col: 18, offset: 9292},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 329, col: 23, offset: 9297},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 329, col: 29, offset: 9303},
								expr: &ruleRefExpr{
									pos:  position{line: 329, col: 29, offset: 9303},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 329, col: 46, offset: 9320},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 332, col: 1, offset: 9438},
			expr: &actionExpr{
				pos: position{line: 332, col: 17, offset: 9454},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 332, col: 17, offset: 9454},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 332, col: 17, offset: 9454},
							expr: &charClassMatcher{
								pos:        position{line: 332, col: 17, offset: 9454},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 332, col: 23, offset: 9460},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 332, col: 26, offset: 9463},
							expr: &charClassMatcher{
								pos:        position{line: 332, col: 26, offset: 9463},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 336, col: 1, offset: 9619},
			expr: &actionExpr{
				pos: position{line: 336, col: 19, offset: 9637},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 336, col: 20, offset: 9638},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 336, col: 20, offset: 9638},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 336, col: 30, offset: 9648},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 341, col: 1, offset: 9803},
			expr: &choiceExpr{
				pos: position{line: 341, col: 17, offset: 9819},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 341, col: 17, offset: 9819},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 342, col: 7, offset: 9841},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 343, col: 7, offset: 9869},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 344, col: 7, offset: 9890},
						name: "InFunction",
					},
					&ruleRefExpr{
						pos:  position{line: 345, col: 7, offset: 9907},
						name: "AggregateFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 346, col: 7, offset: 9932},
						name: "MathFunctions",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 348, col: 1, offset: 9947},
			expr: &choiceExpr{
				pos: position{line: 348, col: 20, offset: 9966},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 348, col: 20, offset: 9966},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 349, col: 7, offset: 9995},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 350, col: 7, offset: 10020},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 351, col: 7, offset: 10043},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 352, col: 7, offset: 10087},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 353, col: 7, offset: 10109},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 354, col: 7, offset: 10131},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 355, col: 7, offset: 10152},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 356, col: 7, offset: 10175},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 357, col: 7, offset: 10197},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 358, col: 7, offset: 10221},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 359, col: 7, offset: 10247},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 360, col: 7, offset: 10271},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 361, col: 7, offset: 10293},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 362, col: 7, offset: 10315},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 363, col: 7, offset: 10341},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 365, col: 1, offset: 10357},
			expr: &choiceExpr{
				pos: position{line: 365, col: 26, offset: 10382},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 365, col: 26, offset: 10382},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 366, col: 7, offset: 10398},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 367, col: 7, offset: 10412},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 368, col: 7, offset: 10425},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 369, col: 7, offset: 10446},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 370, col: 7, offset: 10462},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 371, col: 7, offset: 10475},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 372, col: 7, offset: 10490},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 373, col: 7, offset: 10505},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 374, col: 7, offset: 10523},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "AggregateFunctions",
			pos:  position{line: 376, col: 1, offset: 10533},
			expr: &choiceExpr{
				pos: position{line: 376, col: 23, offset: 10555},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 376, col: 23, offset: 10555},
						name: "AvgAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 377, col: 7, offset: 10584},
						name: "CountAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 378, col: 7, offset: 10615},
						name: "MaxAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 379, col: 7, offset: 10644},
						name: "MinAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 380, col: 7, offset: 10673},
						name: "SumAggregateExpression",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 382, col: 1, offset: 10697},
			expr: &choiceExpr{
				pos: position{line: 382, col: 19, offset: 10715},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 382, col: 19, offset: 10715},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 383, col: 7, offset: 10743},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 384, col: 7, offset: 10771},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 385, col: 7, offset: 10798},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 386, col: 7, offset: 10827},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "MathFunctions",
			pos:  position{line: 388, col: 1, offset: 10847},
			expr: &choiceExpr{
				pos: position{line: 388, col: 18, offset: 10864},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 388, col: 18, offset: 10864},
						name: "MathAbsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 389, col: 7, offset: 10888},
						name: "MathAcosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 390, col: 7, offset: 10913},
						name: "MathAsinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 391, col: 7, offset: 10938},
						name: "MathAtanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 392, col: 7, offset: 10963},
						name: "MathCeilingExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 393, col: 7, offset: 10991},
						name: "MathCosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 394, col: 7, offset: 11015},
						name: "MathCotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 395, col: 7, offset: 11039},
						name: "MathDegreesExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 396, col: 7, offset: 11067},
						name: "MathExpExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 397, col: 7, offset: 11091},
						name: "MathFloorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 398, col: 7, offset: 11117},
						name: "MathIntBitNotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 399, col: 7, offset: 11147},
						name: "MathLog10Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 400, col: 7, offset: 11173},
						name: "MathRadiansExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 401, col: 7, offset: 11201},
						name: "MathRoundExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 402, col: 7, offset: 11227},
						name: "MathSignExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 403, col: 7, offset: 11252},
						name: "MathSinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 404, col: 7, offset: 11276},
						name: "MathSqrtExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 405, col: 7, offset: 11301},
						name: "MathSquareExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 406, col: 7, offset: 11328},
						name: "MathTanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 407, col: 7, offset: 11352},
						name: "MathTruncExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 408, col: 7, offset: 11378},
						name: "MathAtn2Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 409, col: 7, offset: 11403},
						name: "MathIntAddExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 410, col: 7, offset: 11430},
						name: "MathIntBitAndExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 411, col: 7, offset: 11460},
						name: "MathIntBitLeftShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 412, col: 7, offset: 11496},
						name: "MathIntBitOrExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 413, col: 7, offset: 11525},
						name: "MathIntBitRightShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 414, col: 7, offset: 11562},
						name: "MathIntBitXorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 415, col: 7, offset: 11592},
						name: "MathIntDivExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 416, col: 7, offset: 11619},
						name: "MathIntModExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 417, col: 7, offset: 11646},
						name: "MathIntMulExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 7, offset: 11673},
						name: "MathIntSubExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 419, col: 7, offset: 11700},
						name: "MathPowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 420, col: 7, offset: 11726},
						name: "MathLogExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 421, col: 7, offset: 11750},
						name: "MathNumberBinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 422, col: 7, offset: 11780},
						name: "MathPiExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 423, col: 7, offset: 11803},
						name: "MathRandExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 425, col: 1, offset: 11823},
			expr: &actionExpr{
				pos: position{line: 425, col: 20, offset: 11842},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 425, col: 20, offset: 11842},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 425, col: 20, offset: 11842},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 425, col: 29, offset: 11851},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 425, col: 32, offset: 11854},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 425, col: 36, offset: 11858},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 425, col: 39, offset: 11861},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 425, col: 50, offset: 11872},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 429, col: 1, offset: 11957},
			expr: &actionExpr{
				pos: position{line: 429, col: 20, offset: 11976},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 429, col: 20, offset: 11976},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 429, col: 20, offset: 11976},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 429, col: 29, offset: 11985},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 429, col: 32, offset: 11988},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 429, col: 36, offset: 11992},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 429, col: 39, offset: 11995},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 429, col: 50, offset: 12006},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 433, col: 1, offset: 12091},
			expr: &actionExpr{
				pos: position{line: 433, col: 27, offset: 12117},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 433, col: 27, offset: 12117},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 433, col: 27, offset: 12117},
							val:        "stringequals",
							ignoreCase: true,
							want:       "\"STRINGEQUALS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 433, col: 43, offset: 12133},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 433, col: 46, offset: 12136},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 433, col: 50, offset: 12140},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 433, col: 53, offset: 12143},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 433, col: 57, offset: 12147},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 433, col: 68, offset: 12158},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 433, col: 71, offset: 12161},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 433, col: 75, offset: 12165},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 433, col: 78, offset: 12168},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 433, col: 82, offset: 12172},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 433, col: 93, offset: 12183},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 433, col: 96, offset: 12186},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 433, col: 107, offset: 12197},
								expr: &actionExpr{
									pos: position{line: 433, col: 108, offset: 12198},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 433, col: 108, offset: 12198},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 433, col: 108, offset: 12198},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 433, col: 112, offset: 12202},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 433, col: 115, offset: 12205},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 433, col: 123, offset: 12213},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 433, col: 160, offset: 12250},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 437, col: 1, offset: 12360},
			expr: &actionExpr{
				pos: position{line: 437, col: 23, offset: 12382},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 437, col: 23, offset: 12382},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 437, col: 23, offset: 12382},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 437, col: 35, offset: 12394},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 437, col: 38, offset: 12397},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 437, col: 42, offset: 12401},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 437, col: 45, offset: 12404},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 437, col: 48, offset: 12407},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 437, col: 59, offset: 12418},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 437, col: 62, offset: 12421},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 441, col: 1, offset: 12509},
			expr: &actionExpr{
				pos: position{line: 441, col: 21, offset: 12529},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 441, col: 21, offset: 12529},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 441, col: 21, offset: 12529},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 441, col: 31, offset: 12539},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 441, col: 34, offset: 12542},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 441, col: 38, offset: 12546},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 441, col: 41, offset: 12549},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 441, col: 45, offset: 12553},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 441, col: 56, offset: 12564},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 441, col: 63, offset: 12571},
								expr: &actionExpr{
									pos: position{line: 441, col: 64, offset: 12572},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 441, col: 64, offset: 12572},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 441, col: 64, offset: 12572},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 441, col: 67, offset: 12575},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 441, col: 71, offset: 12579},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 441, col: 74, offset: 12582},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 441, col: 77, offset: 12585},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 441, col: 109, offset: 12617},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 441, col: 112, offset: 12620},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 446, col: 1, offset: 12769},
			expr: &actionExpr{
				pos: position{line: 446, col: 19, offset: 12787},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 446, col: 19, offset: 12787},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 446, col: 19, offset: 12787},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 446, col: 27, offset: 12795},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 446, col: 30, offset: 12798},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 446, col: 34, offset: 12802},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 446, col: 37, offset: 12805},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 446, col: 40, offset: 12808},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 446, col: 51, offset: 12819},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 446, col: 54, offset: 12822},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 446, col: 58, offset: 12826},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 446, col: 61, offset: 12829},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 446, col: 68, offset: 12836},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 446, col: 79, offset: 12847},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 446, col: 82, offset: 12850},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 450, col: 1, offset: 12942},
			expr: &actionExpr{
				pos: position{line: 450, col: 21, offset: 12962},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 450, col: 21, offset: 12962},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 450, col: 21, offset: 12962},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 450, col: 31, offset: 12972},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 450, col: 34, offset: 12975},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 450, col: 38, offset: 12979},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 450, col: 41, offset: 12982},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 450, col: 44, offset: 12985},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 450, col: 55, offset: 12996},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 450, col: 58, offset: 12999},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 454, col: 1, offset: 13085},
			expr: &actionExpr{
				pos: position{line: 454, col: 20, offset: 13104},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 454, col: 20, offset: 13104},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 454, col: 20, offset: 13104},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 454, col: 29, offset: 13113},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 454, col: 32, offset: 13116},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 454, col: 36, offset: 13120},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 454, col: 39, offset: 13123},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 454, col: 42, offset: 13126},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 454, col: 53, offset: 13137},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 454, col: 56, offset: 13140},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 458, col: 1, offset: 13225},
			expr: &actionExpr{
				pos: position{line: 458, col: 22, offset: 13246},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 458, col: 22, offset: 13246},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 458, col: 22, offset: 13246},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 33, offset: 13257},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 458, col: 36, offset: 13260},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 40, offset: 13264},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 458, col: 43, offset: 13267},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 458, col: 47, offset: 13271},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 58, offset: 13282},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 458, col: 61, offset: 13285},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 65, offset: 13289},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 458, col: 68, offset: 13292},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 458, col: 72, offset: 13296},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 83, offset: 13307},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 458, col: 86, offset: 13310},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 90, offset: 13314},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 458, col: 93, offset: 13317},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 458, col: 97, offset: 13321},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 458, col: 108, offset: 13332},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 458, col: 111, offset: 13335},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 462, col: 1, offset: 13433},
			expr: &actionExpr{
				pos: position{line: 462, col: 24, offset: 13456},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 462, col: 24, offset: 13456},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 462, col: 24, offset: 13456},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 462, col: 37, offset: 13469},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 462, col: 40, offset: 13472},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 462, col: 44, offset: 13476},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 462, col: 47, offset: 13479},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 462, col: 51, offset: 13483},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 462, col: 62, offset: 13494},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 462, col: 65, offset: 13497},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 462, col: 69, offset: 13501},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 462, col: 72, offset: 13504},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 462, col: 76, offset: 13508},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 462, col: 87, offset: 13519},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 462, col: 90, offset: 13522},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 466, col: 1, offset: 13617},
			expr: &actionExpr{
				pos: position{line: 466, col: 22, offset: 13638},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 466, col: 22, offset: 13638},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 466, col: 22, offset: 13638},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 466, col: 33, offset: 13649},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 466, col: 36, offset: 13652},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 466, col: 40, offset: 13656},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 466, col: 43, offset: 13659},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 466, col: 46, offset: 13662},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 466, col: 57, offset: 13673},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 466, col: 60, offset: 13676},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 470, col: 1, offset: 13763},
			expr: &actionExpr{
				pos: position{line: 470, col: 20, offset: 13782},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 470, col: 20, offset: 13782},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 470, col: 20, offset: 13782},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 470, col: 29, offset: 13791},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 470, col: 32, offset: 13794},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 470, col: 36, offset: 13798},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 470, col: 39, offset: 13801},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 470, col: 42, offset: 13804},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 470, col: 53, offset: 13815},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 470, col: 56, offset: 13818},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 470, col: 60, offset: 13822},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 470, col: 63, offset: 13825},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 470, col: 70, offset: 13832},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 470, col: 81, offset: 13843},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 470, col: 84, offset: 13846},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 474, col: 1, offset: 13939},
			expr: &actionExpr{
				pos: position{line: 474, col: 20, offset: 13958},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 474, col: 20, offset: 13958},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 474, col: 20, offset: 13958},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 474, col: 29, offset: 13967},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 474, col: 32, offset: 13970},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 474, col: 36, offset: 13974},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 474, col: 39, offset: 13977},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 474, col: 42, offset: 13980},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 474, col: 53, offset: 13991},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 474, col: 56, offset: 13994},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 478, col: 1, offset: 14079},
			expr: &actionExpr{
				pos: position{line: 478, col: 24, offset: 14102},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 478, col: 24, offset: 14102},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 478, col: 24, offset: 14102},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 37, offset: 14115},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 478, col: 40, offset: 14118},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 44, offset: 14122},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 478, col: 47, offset: 14125},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 478, col: 50, offset: 14128},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 61, offset: 14139},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 478, col: 64, offset: 14142},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 68, offset: 14146},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 478, col: 71, offset: 14149},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 478, col: 80, offset: 14158},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 91, offset: 14169},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 478, col: 94, offset: 14172},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 98, offset: 14176},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 478, col: 101, offset: 14179},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 478, col: 108, offset: 14186},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 478, col: 119, offset: 14197},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 478, col: 122, offset: 14200},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 482, col: 1, offset: 14307},
			expr: &actionExpr{
				pos: position{line: 482, col: 19, offset: 14325},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 482, col: 19, offset: 14325},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 482, col: 19, offset: 14325},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 482, col: 27, offset: 14333},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 482, col: 30, offset: 14336},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 482, col: 34, offset: 14340},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 482, col: 37, offset: 14343},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 482, col: 40, offset: 14346},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 482, col: 51, offset: 14357},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 482, col: 54, offset: 14360},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 486, col: 1, offset: 14444},
			expr: &actionExpr{
				pos: position{line: 486, col: 42, offset: 14485},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 486, col: 42, offset: 14485},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 486, col: 42, offset: 14485},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 486, col: 51, offset: 14494},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 486, col: 79, offset: 14522},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 486, col: 82, offset: 14525},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 486, col: 86, offset: 14529},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 486, col: 89, offset: 14532},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 486, col: 93, offset: 14536},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 486, col: 104, offset: 14547},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 486, col: 107, offset: 14550},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 486, col: 111, offset: 14554},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 486, col: 114, offset: 14557},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 486, col: 118, offset: 14561},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 486, col: 129, offset: 14572},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 486, col: 132, offset: 14575},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 486, col: 143, offset: 14586},
								expr: &actionExpr{
									pos: position{line: 486, col: 144, offset: 14587},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 486, col: 144, offset: 14587},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 486, col: 144, offset: 14587},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 486, col: 148, offset: 14591},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 486, col: 151, offset: 14594},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 486, col: 159, offset: 14602},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 486, col: 196, offset: 14639},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 504, col: 1, offset: 15161},
			expr: &actionExpr{
				pos: position{line: 504, col: 32, offset: 15192},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 504, col: 33, offset: 15193},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 504, col: 33, offset: 15193},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 504, col: 47, offset: 15207},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 504, col: 61, offset: 15221},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 504, col: 77, offset: 15237},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 508, col: 1, offset: 15286},
			expr: &actionExpr{
				pos: position{line: 508, col: 14, offset: 15299},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 508, col: 14, offset: 15299},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 508, col: 14, offset: 15299},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 28, offset: 15313},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 508, col: 31, offset: 15316},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 35, offset: 15320},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 508, col: 38, offset: 15323},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 508, col: 41, offset: 15326},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 52, offset: 15337},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 508, col: 55, offset: 15340},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 512, col: 1, offset: 15429},
			expr: &actionExpr{
				pos: position{line: 512, col: 12, offset: 15440},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 512, col: 12, offset: 15440},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 512, col: 12, offset: 15440},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 512, col: 24, offset: 15452},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 512, col: 27, offset: 15455},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 512, col: 31, offset: 15459},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 512, col: 34, offset: 15462},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 512, col: 37, offset: 15465},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 512, col: 48, offset: 15476},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 512, col: 51, offset: 15479},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 516, col: 1, offset: 15566},
			expr: &actionExpr{
				pos: position{line: 516, col: 11, offset: 15576},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 516, col: 11, offset: 15576},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 516, col: 11, offset: 15576},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 516, col: 22, offset: 15587},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 516, col: 25, offset: 15590},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 516, col: 29, offset: 15594},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 516, col: 32, offset: 15597},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 516, col: 35, offset: 15600},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 516, col: 46, offset: 15611},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 516, col: 49, offset: 15614},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 520, col: 1, offset: 15700},
			expr: &actionExpr{
				pos: position{line: 520, col: 19, offset: 15718},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 520, col: 19, offset: 15718},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 520, col: 19, offset: 15718},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 520, col: 39, offset: 15738},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 520, col: 42, offset: 15741},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 520, col: 46, offset: 15745},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 520, col: 49, offset: 15748},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 520, col: 52, offset: 15751},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 520, col: 63, offset: 15762},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 520, col: 66, offset: 15765},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 524, col: 1, offset: 15859},
			expr: &actionExpr{
				pos: position{line: 524, col: 14, offset: 15872},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 524, col: 14, offset: 15872},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 524, col: 14, offset: 15872},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 524, col: 28, offset: 15886},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 524, col: 31, offset: 15889},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 524, col: 35, offset: 15893},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 524, col: 38, offset: 15896},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 524, col: 41, offset: 15899},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 524, col: 52, offset: 15910},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 524, col: 55, offset: 15913},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 528, col: 1, offset: 16002},
			expr: &actionExpr{
				pos: position{line: 528, col: 11, offset: 16012},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 528, col: 11, offset: 16012},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 528, col: 11, offset: 16012},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 528, col: 22, offset: 16023},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 528, col: 25, offset: 16026},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 528, col: 29, offset: 16030},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 528, col: 32, offset: 16033},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 528, col: 35, offset: 16036},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 528, col: 46, offset: 16047},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 528, col: 49, offset: 16050},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 532, col: 1, offset: 16136},
			expr: &actionExpr{
				pos: position{line: 532, col: 13, offset: 16148},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 532, col: 13, offset: 16148},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 532, col: 13, offset: 16148},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 532, col: 26, offset: 16161},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 532, col: 29, offset: 16164},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 532, col: 33, offset: 16168},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 532, col: 36, offset: 16171},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 532, col: 39, offset: 16174},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 532, col: 50, offset: 16185},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 532, col: 53, offset: 16188},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 536, col: 1, offset: 16276},
			expr: &actionExpr{
				pos: position{line: 536, col: 13, offset: 16288},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 536, col: 13, offset: 16288},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 536, col: 13, offset: 16288},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 536, col: 26, offset: 16301},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 536, col: 29, offset: 16304},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 536, col: 33, offset: 16308},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 536, col: 36, offset: 16311},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 536, col: 39, offset: 16314},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 536, col: 50, offset: 16325},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 536, col: 53, offset: 16328},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 540, col: 1, offset: 16416},
			expr: &actionExpr{
				pos: position{line: 540, col: 16, offset: 16431},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 540, col: 16, offset: 16431},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 540, col: 16, offset: 16431},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 540, col: 32, offset: 16447},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 540, col: 35, offset: 16450},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 540, col: 39, offset: 16454},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 540, col: 42, offset: 16457},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 540, col: 45, offset: 16460},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 540, col: 56, offset: 16471},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 540, col: 59, offset: 16474},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 544, col: 1, offset: 16565},
			expr: &actionExpr{
				pos: position{line: 544, col: 13, offset: 16577},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 544, col: 13, offset: 16577},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 544, col: 13, offset: 16577},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 544, col: 26, offset: 16590},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 544, col: 29, offset: 16593},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 544, col: 33, offset: 16597},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 544, col: 36, offset: 16600},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 544, col: 39, offset: 16603},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 544, col: 50, offset: 16614},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 544, col: 53, offset: 16617},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 548, col: 1, offset: 16705},
			expr: &actionExpr{
				pos: position{line: 548, col: 26, offset: 16730},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 548, col: 26, offset: 16730},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 548, col: 26, offset: 16730},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 548, col: 42, offset: 16746},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 548, col: 45, offset: 16749},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 548, col: 49, offset: 16753},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 548, col: 52, offset: 16756},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 548, col: 59, offset: 16763},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 548, col: 70, offset: 16774},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 548, col: 77, offset: 16781},
								expr: &actionExpr{
									pos: position{line: 548, col: 78, offset: 16782},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 548, col: 78, offset: 16782},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 548, col: 78, offset: 16782},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 548, col: 81, offset: 16785},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 548, col: 85, offset: 16789},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 548, col: 88, offset: 16792},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 548, col: 91, offset: 16795},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 548, col: 123, offset: 16827},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 548, col: 126, offset: 16830},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 552, col: 1, offset: 16960},
			expr: &actionExpr{
				pos: position{line: 552, col: 26, offset: 16985},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 552, col: 26, offset: 16985},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 552, col: 26, offset: 16985},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 552, col: 42, offset: 17001},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 552, col: 45, offset: 17004},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 552, col: 49, offset: 17008},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 552, col: 52, offset: 17011},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 552, col: 58, offset: 17017},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 552, col: 69, offset: 17028},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 552, col: 72, offset: 17031},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 556, col: 1, offset: 17125},
			expr: &actionExpr{
				pos: position{line: 556, col: 25, offset: 17149},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 556, col: 25, offset: 17149},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 556, col: 25, offset: 17149},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 556, col: 40, offset: 17164},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 556, col: 43, offset: 17167},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 556, col: 47, offset: 17171},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 556, col: 50, offset: 17174},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 556, col: 56, offset: 17180},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 556, col: 67, offset: 17191},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 556, col: 70, offset: 17194},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 556, col: 74, offset: 17198},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 556, col: 77, offset: 17201},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 556, col: 83, offset: 17207},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 556, col: 94, offset: 17218},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 556, col: 101, offset: 17225},
								expr: &actionExpr{
									pos: position{line: 556, col: 102, offset: 17226},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 556, col: 102, offset: 17226},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 556, col: 102, offset: 17226},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 556, col: 105, offset: 17229},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 556, col: 109, offset: 17233},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 556, col: 112, offset: 17236},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 556, col: 115, offset: 17239},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 556, col: 147, offset: 17271},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 556, col: 150, offset: 17274},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 560, col: 1, offset: 17382},
			expr: &actionExpr{
				pos: position{line: 560, col: 27, offset: 17408},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 560, col: 27, offset: 17408},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 560, col: 27, offset: 17408},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 560, col: 43, offset: 17424},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 560, col: 46, offset: 17427},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 560, col: 50, offset: 17431},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 560, col: 53, offset: 17434},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 560, col: 58, offset: 17439},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 560, col: 69, offset: 17450},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 560, col: 72, offset: 17453},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 560, col: 76, offset: 17457},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 560, col: 79, offset: 17460},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 560, col: 84, offset: 17465},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 560, col: 95, offset: 17476},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 560, col: 98, offset: 17479},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 564, col: 1, offset: 17579},
			expr: &actionExpr{
				pos: position{line: 564, col: 23, offset: 17601},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 564, col: 23, offset: 17601},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 564, col: 23, offset: 17601},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 564, col: 35, offset: 17613},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 564, col: 38, offset: 17616},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 564, col: 42, offset: 17620},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 564, col: 45, offset: 17623},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 564, col: 50, offset: 17628},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 564, col: 61, offset: 17639},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 564, col: 64, offset: 17642},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 564, col: 68, offset: 17646},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 564, col: 71, offset: 17649},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 564, col: 76, offset: 17654},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 564, col: 87, offset: 17665},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 564, col: 90, offset: 17668},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAbsExpression",
			pos:  position{line: 568, col: 1, offset: 17764},
			expr: &actionExpr{
				pos: position{line: 568, col: 22, offset: 17785},
				run: (*parser).callonMathAbsExpression1,
				expr: &seqExpr{
					pos: position{line: 568, col: 22, offset: 17785},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 568, col: 22, offset: 17785},
							val:        "abs",
							ignoreCase: true,
							want:       "\"ABS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 568, col: 29, offset: 17792},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 568, col: 32, offset: 17795},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 568, col: 36, offset: 17799},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 568, col: 39, offset: 17802},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 568, col: 42, offset: 17805},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 568, col: 53, offset: 17816},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 568, col: 56, offset: 17819},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAcosExpression",
			pos:  position{line: 569, col: 1, offset: 17901},
			expr: &actionExpr{
				pos: position{line: 569, col: 23, offset: 17923},
				run: (*parser).callonMathAcosExpression1,
				expr: &seqExpr{
					pos: position{line: 569, col: 23, offset: 17923},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 569, col: 23, offset: 17923},
							val:        "acos",
							ignoreCase: true,
							want:       "\"ACOS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 569, col: 31, offset: 17931},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 569, col: 34, offset: 17934},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 569, col: 38, offset: 17938},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 569, col: 41, offset: 17941},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 569, col: 44, offset: 17944},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 569, col: 55, offset: 17955},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 569, col: 58, offset: 17958},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAsinExpression",
			pos:  position{line: 570, col: 1, offset: 18041},
			expr: &actionExpr{
				pos: position{line: 570, col: 23, offset: 18063},
				run: (*parser).callonMathAsinExpression1,
				expr: &seqExpr{
					pos: position{line: 570, col: 23, offset: 18063},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 570, col: 23, offset: 18063},
							val:        "asin",
							ignoreCase: true,
							want:       "\"ASIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 31, offset: 18071},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 34, offset: 18074},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 38, offset: 18078},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 570, col: 41, offset: 18081},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 570, col: 44, offset: 18084},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 55, offset: 18095},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 58, offset: 18098},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtanExpression",
			pos:  position{line: 571, col: 1, offset: 18181},
			expr: &actionExpr{
				pos: position{line: 571, col: 23, offset: 18203},
				run: (*parser).callonMathAtanExpression1,
				expr: &seqExpr{
					pos: position{line: 571, col: 23, offset: 18203},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 571, col: 23, offset: 18203},
							val:        "atan",
							ignoreCase: true,
							want:       "\"ATAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 571, col: 31, offset: 18211},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 571, col: 34, offset: 18214},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 571, col: 38, offset: 18218},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 571, col: 41, offset: 18221},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 571, col: 44, offset: 18224},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 571, col: 55, offset: 18235},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 571, col: 58, offset: 18238},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCeilingExpression",
			pos:  position{line: 572, col: 1, offset: 18321},
			expr: &actionExpr{
				pos: position{line: 572, col: 26, offset: 18346},
				run: (*parser).callonMathCeilingExpression1,
				expr: &seqExpr{
					pos: position{line: 572, col: 26, offset: 18346},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 572, col: 26, offset: 18346},
							val:        "ceiling",
							ignoreCase: true,
							want:       "\"CEILING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 37, offset: 18357},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 572, col: 40, offset: 18360},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 44, offset: 18364},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 572, col: 47, offset: 18367},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 572, col: 50, offset: 18370},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 61, offset: 18381},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 572, col: 64, offset: 18384},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCosExpression",
			pos:  position{line: 573, col: 1, offset: 18470},
			expr: &actionExpr{
				pos: position{line: 573, col: 22, offset: 18491},
				run: (*parser).callonMathCosExpression1,
				expr: &seqExpr{
					pos: position{line: 573, col: 22, offset: 18491},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 573, col: 22, offset: 18491},
							val:        "cos",
							ignoreCase: true,
							want:       "\"COS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 573, col: 29, offset: 18498},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 573, col: 32, offset: 18501},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 573, col: 36, offset: 18505},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 573, col: 39, offset: 18508},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 573, col: 42, offset: 18511},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 573, col: 53, offset: 18522},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 573, col: 56, offset: 18525},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCotExpression",
			pos:  position{line: 574, col: 1, offset: 18607},
			expr: &actionExpr{
				pos: position{line: 574, col: 22, offset: 18628},
				run: (*parser).callonMathCotExpression1,
				expr: &seqExpr{
					pos: position{line: 574, col: 22, offset: 18628},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 574, col: 22, offset: 18628},
							val:        "cot",
							ignoreCase: true,
							want:       "\"COT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 29, offset: 18635},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 32, offset: 18638},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 36, offset: 18642},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 574, col: 39, offset: 18645},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 574, col: 42, offset: 18648},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 53, offset: 18659},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 56, offset: 18662},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathDegreesExpression",
			pos:  position{line: 575, col: 1, offset: 18744},
			expr: &actionExpr{
				pos: position{line: 575, col: 26, offset: 18769},
				run: (*parser).callonMathDegreesExpression1,
				expr: &seqExpr{
					pos: position{line: 575, col: 26, offset: 18769},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 575, col: 26, offset: 18769},
							val:        "degrees",
							ignoreCase: true,
							want:       "\"DEGREES\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 575, col: 37, offset: 18780},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 575, col: 40, offset: 18783},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 575, col: 44, offset: 18787},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 575, col: 47, offset: 18790},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 575, col: 50, offset: 18793},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 575, col: 61, offset: 18804},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 575, col: 64, offset: 18807},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathExpExpression",
			pos:  position{line: 576, col: 1, offset: 18893},
			expr: &actionExpr{
				pos: position{line: 576, col: 22, offset: 18914},
				run: (*parser).callonMathExpExpression1,
				expr: &seqExpr{
					pos: position{line: 576, col: 22, offset: 18914},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 576, col: 22, offset: 18914},
							val:        "exp",
							ignoreCase: true,
							want:       "\"EXP\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 576, col: 29, offset: 18921},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 576, col: 32, offset: 18924},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 576, col: 36, offset: 18928},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 576, col: 39, offset: 18931},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 576, col: 42, offset: 18934},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 576, col: 53, offset: 18945},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 576, col: 56, offset: 18948},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathFloorExpression",
			pos:  position{line: 577, col: 1, offset: 19030},
			expr: &actionExpr{
				pos: position{line: 577, col: 24, offset: 19053},
				run: (*parser).callonMathFloorExpression1,
				expr: &seqExpr{
					pos: position{line: 577, col: 24, offset: 19053},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 577, col: 24, offset: 19053},
							val:        "floor",
							ignoreCase: true,
							want:       "\"FLOOR\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 577, col: 33, offset: 19062},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 577, col: 36, offset: 19065},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 577, col: 40, offset: 19069},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 577, col: 43, offset: 19072},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 577, col: 46, offset: 19075},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 577, col: 57, offset: 19086},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 577, col: 60, offset: 19089},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitNotExpression",
			pos:  position{line: 578, col: 1, offset: 19173},
			expr: &actionExpr{
				pos: position{line: 578, col: 28, offset: 19200},
				run: (*parser).callonMathIntBitNotExpression1,
				expr: &seqExpr{
					pos: position{line: 578, col: 28, offset: 19200},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 578, col: 28, offset: 19200},
							val:        "intbitnot",
							ignoreCase: true,
							want:       "\"IntBitNot\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 41, offset: 19213},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 578, col: 44, offset: 19216},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 48, offset: 19220},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 578, col: 51, offset: 19223},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 578, col: 54, offset: 19226},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 65, offset: 19237},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 578, col: 68, offset: 19240},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLog10Expression",
			pos:  position{line: 579, col: 1, offset: 19328},
			expr: &actionExpr{
				pos: position{line: 579, col: 24, offset: 19351},
				run: (*parser).callonMathLog10Expression1,
				expr: &seqExpr{
					pos: position{line: 579, col: 24, offset: 19351},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 579, col: 24, offset: 19351},
							val:        "log10",
							ignoreCase: true,
							want:       "\"LOG10\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 579, col: 33, offset: 19360},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 579, col: 36, offset: 19363},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 579, col: 40, offset: 19367},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 579, col: 43, offset: 19370},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 579, col: 46, offset: 19373},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 579, col: 57, offset: 19384},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 579, col: 60, offset: 19387},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRadiansExpression",
			pos:  position{line: 580, col: 1, offset: 19471},
			expr: &actionExpr{
				pos: position{line: 580, col: 26, offset: 19496},
				run: (*parser).callonMathRadiansExpression1,
				expr: &seqExpr{
					pos: position{line: 580, col: 26, offset: 19496},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 580, col: 26, offset: 19496},
							val:        "radians",
							ignoreCase: true,
							want:       "\"RADIANS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 580, col: 37, offset: 19507},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 580, col: 40, offset: 19510},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 580, col: 44, offset: 19514},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 580, col: 47, offset: 19517},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 580, col: 50, offset: 19520},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 580, col: 61, offset: 19531},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 580, col: 64, offset: 19534},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRoundExpression",
			pos:  position{line: 581, col: 1, offset: 19620},
			expr: &actionExpr{
				pos: position{line: 581, col: 24, offset: 19643},
				run: (*parser).callonMathRoundExpression1,
				expr: &seqExpr{
					pos: position{line: 581, col: 24, offset: 19643},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 581, col: 24, offset: 19643},
							val:        "round",
							ignoreCase: true,
							want:       "\"ROUND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 581, col: 33, offset: 19652},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 581, col: 36, offset: 19655},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 581, col: 40, offset: 19659},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 581, col: 43, offset: 19662},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 581, col: 46, offset: 19665},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 581, col: 57, offset: 19676},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 581, col: 60, offset: 19679},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSignExpression",
			pos:  position{line: 582, col: 1, offset: 19763},
			expr: &actionExpr{
				pos: position{line: 582, col: 23, offset: 19785},
				run: (*parser).callonMathSignExpression1,
				expr: &seqExpr{
					pos: position{line: 582, col: 23, offset: 19785},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 582, col: 23, offset: 19785},
							val:        "sign",
							ignoreCase: true,
							want:       "\"SIGN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 31, offset: 19793},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 34, offset: 19796},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 38, offset: 19800},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 582, col: 41, offset: 19803},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 582, col: 44, offset: 19806},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 55, offset: 19817},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 58, offset: 19820},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSinExpression",
			pos:  position{line: 583, col: 1, offset: 19903},
			expr: &actionExpr{
				pos: position{line: 583, col: 22, offset: 19924},
				run: (*parser).callonMathSinExpression1,
				expr: &seqExpr{
					pos: position{line: 583, col: 22, offset: 19924},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 583, col: 22, offset: 19924},
							val:        "sin",
							ignoreCase: true,
							want:       "\"SIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 583, col: 29, offset: 19931},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 583, col: 32, offset: 19934},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 583, col: 36, offset: 19938},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 583, col: 39, offset: 19941},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 583, col: 42, offset: 19944},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 583, col: 53, offset: 19955},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 583, col: 56, offset: 19958},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSqrtExpression",
			pos:  position{line: 584, col: 1, offset: 20040},
			expr: &actionExpr{
				pos: position{line: 584, col: 23, offset: 20062},
				run: (*parser).callonMathSqrtExpression1,
				expr: &seqExpr{
					pos: position{line: 584, col: 23, offset: 20062},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 584, col: 23, offset: 20062},
							val:        "sqrt",
							ignoreCase: true,
							want:       "\"SQRT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 584, col: 31, offset: 20070},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 584, col: 34, offset: 20073},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 584, col: 38, offset: 20077},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 584, col: 41, offset: 20080},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 584, col: 44, offset: 20083},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 584, col: 55, offset: 20094},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 584, col: 58, offset: 20097},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSquareExpression",
			pos:  position{line: 585, col: 1, offset: 20180},
			expr: &actionExpr{
				pos: position{line: 585, col: 25, offset: 20204},
				run: (*parser).callonMathSquareExpression1,
				expr: &seqExpr{
					pos: position{line: 585, col: 25, offset: 20204},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 585, col: 25, offset: 20204},
							val:        "square",
							ignoreCase: true,
							want:       "\"SQUARE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 35, offset: 20214},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 585, col: 38, offset: 20217},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 42, offset: 20221},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 585, col: 45, offset: 20224},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 585, col: 48, offset: 20227},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 59, offset: 20238},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 585, col: 62, offset: 20241},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTanExpression",
			pos:  position{line: 586, col: 1, offset: 20326},
			expr: &actionExpr{
				pos: position{line: 586, col: 22, offset: 20347},
				run: (*parser).callonMathTanExpression1,
				expr: &seqExpr{
					pos: position{line: 586, col: 22, offset: 20347},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 586, col: 22, offset: 20347},
							val:        "tan",
							ignoreCase: true,
							want:       "\"TAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 29, offset: 20354},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 586, col: 32, offset: 20357},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 36, offset: 20361},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 586, col: 39, offset: 20364},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 586, col: 42, offset: 20367},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 53, offset: 20378},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 586, col: 56, offset: 20381},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTruncExpression",
			pos:  position{line: 587, col: 1, offset: 20463},
			expr: &actionExpr{
				pos: position{line: 587, col: 24, offset: 20486},
				run: (*parser).callonMathTruncExpression1,
				expr: &seqExpr{
					pos: position{line: 587, col: 24, offset: 20486},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 587, col: 24, offset: 20486},
							val:        "trunc",
							ignoreCase: true,
							want:       "\"TRUNC\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 587, col: 33, offset: 20495},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 587, col: 36, offset: 20498},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 587, col: 40, offset: 20502},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 587, col: 43, offset: 20505},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 587, col: 46, offset: 20508},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 587, col: 57, offset: 20519},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 587, col: 60, offset: 20522},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtn2Expression",
			pos:  position{line: 589, col: 1, offset: 20607},
			expr: &actionExpr{
				pos: position{line: 589, col: 23, offset: 20629},
				run: (*parser).callonMathAtn2Expression1,
				expr: &seqExpr{
					pos: position{line: 589, col: 23, offset: 20629},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 589, col: 23, offset: 20629},
							val:        "atn2",
							ignoreCase: true,
							want:       "\"ATN2\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 31, offset: 20637},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 589, col: 34, offset: 20640},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 38, offset: 20644},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 589, col: 41, offset: 20647},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 589, col: 46, offset: 20652},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 57, offset: 20663},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 589, col: 60, offset: 20666},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 64, offset: 20670},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 589, col: 67, offset: 20673},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 589, col: 72, offset: 20678},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 83, offset: 20689},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 589, col: 86, offset: 20692},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntAddExpression",
			pos:  position{line: 590, col: 1, offset: 20783},
			expr: &actionExpr{
				pos: position{line: 590, col: 25, offset: 20807},
				run: (*parser).callonMathIntAddExpression1,
				expr: &seqExpr{
					pos: position{line: 590, col: 25, offset: 20807},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 590, col: 25, offset: 20807},
							val:        "intadd",
							ignoreCase: true,
							want:       "\"IntAdd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 35, offset: 20817},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 38, offset: 20820},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 42, offset: 20824},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 45, offset: 20827},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 50, offset: 20832},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 61, offset: 20843},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 64, offset: 20846},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 68, offset: 20850},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 71, offset: 20853},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 76, offset: 20858},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 87, offset: 20869},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 90, offset: 20872},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitAndExpression",
			pos:  position{line: 591, col: 1, offset: 20965},
			expr: &actionExpr{
				pos: position{line: 591, col: 28, offset: 20992},
				run: (*parser).callonMathIntBitAndExpression1,
				expr: &seqExpr{
					pos: position{line: 591, col: 28, offset: 20992},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 591, col: 28, offset: 20992},
							val:        "intbitand",
							ignoreCase: true,
							want:       "\"IntBitAnd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 591, col: 41, offset: 21005},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 591, col: 44, offset: 21008},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 591, col: 48, offset: 21012},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 591, col: 51, offset: 21015},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 591, col: 56, offset: 21020},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 591, col: 67, offset: 21031},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 591, col: 70, offset: 21034},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 591, col: 74, offset: 21038},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 591, col: 77, offset: 21041},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 591, col: 82, offset: 21046},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 591, col: 93, offset: 21057},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 591, col: 96, offset: 21060},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitLeftShiftExpression",
			pos:  position{line: 592, col: 1, offset: 21156},
			expr: &actionExpr{
				pos: position{line: 592, col: 34, offset: 21189},
				run: (*parser).callonMathIntBitLeftShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 592, col: 34, offset: 21189},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 592, col: 34, offset: 21189},
							val:        "intbitleftshift",
							ignoreCase: true,
							want:       "\"IntBitLeftShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 53, offset: 21208},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 592, col: 56, offset: 21211},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 60, offset: 21215},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 592, col: 63, offset: 21218},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 592, col: 68, offset: 21223},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 79, offset: 21234},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 592, col: 82, offset: 21237},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 86, offset: 21241},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 592, col: 89, offset: 21244},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 592, col: 94, offset: 21249},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 105, offset: 21260},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 592, col: 108, offset: 21263},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitOrExpression",
			pos:  position{line: 593, col: 1, offset: 21365},
			expr: &actionExpr{
				pos: position{line: 593, col: 27, offset: 21391},
				run: (*parser).callonMathIntBitOrExpression1,
				expr: &seqExpr{
					pos: position{line: 593, col: 27, offset: 21391},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 593, col: 27, offset: 21391},
							val:        "intbitor",
							ignoreCase: true,
							want:       "\"IntBitOr\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 39, offset: 21403},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 593, col: 42, offset: 21406},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 46, offset: 21410},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 593, col: 49, offset: 21413},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 593, col: 54, offset: 21418},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 65, offset: 21429},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 593, col: 68, offset: 21432},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 72, offset: 21436},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 593, col: 75, offset: 21439},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 593, col: 80, offset: 21444},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 91, offset: 21455},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 593, col: 94, offset: 21458},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitRightShiftExpression",
			pos:  position{line: 594, col: 1, offset: 21553},
			expr: &actionExpr{
				pos: position{line: 594, col: 35, offset: 21587},
				run: (*parser).callonMathIntBitRightShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 594, col: 35, offset: 21587},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 594, col: 35, offset: 21587},
							val:        "intbitrightshift",
							ignoreCase: true,
							want:       "\"IntBitRightShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 55, offset: 21607},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 594, col: 58, offset: 21610},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 62, offset: 21614},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 594, col: 65, offset: 21617},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 594, col: 70, offset: 21622},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 81, offset: 21633},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 594, col: 84, offset: 21636},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 88, offset: 21640},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 594, col: 91, offset: 21643},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 594, col: 96, offset: 21648},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 594, col: 107, offset: 21659},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 594, col: 110, offset: 21662},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitXorExpression",
			pos:  position{line: 595, col: 1, offset: 21765},
			expr: &actionExpr{
				pos: position{line: 595, col: 28, offset: 21792},
				run: (*parser).callonMathIntBitXorExpression1,
				expr: &seqExpr{
					pos: position{line: 595, col: 28, offset: 21792},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 595, col: 28, offset: 21792},
							val:        "intbitxor",
							ignoreCase: true,
							want:       "\"IntBitXor\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 595, col: 41, offset: 21805},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 595, col: 44, offset: 21808},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 595, col: 48, offset: 21812},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 595, col: 51, offset: 21815},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 595, col: 56, offset: 21820},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 595, col: 67, offset: 21831},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 595, col: 70, offset: 21834},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 595, col: 74, offset: 21838},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 595, col: 77, offset: 21841},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 595, col: 82, offset: 21846},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 595, col: 93, offset: 21857},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 595, col: 96, offset: 21860},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntDivExpression",
			pos:  position{line: 596, col: 1, offset: 21956},
			expr: &actionExpr{
				pos: position{line: 596, col: 25, offset: 21980},
				run: (*parser).callonMathIntDivExpression1,
				expr: &seqExpr{
					pos: position{line: 596, col: 25, offset: 21980},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 596, col: 25, offset: 21980},
							val:        "intdiv",
							ignoreCase: true,
							want:       "\"IntDiv\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 35, offset: 21990},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 596, col: 38, offset: 21993},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 42, offset: 21997},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 596, col: 45, offset: 22000},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 596, col: 50, offset: 22005},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 61, offset: 22016},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 596, col: 64, offset: 22019},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 68, offset: 22023},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 596, col: 71, offset: 22026},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 596, col: 76, offset: 22031},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 87, offset: 22042},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 596, col: 90, offset: 22045},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntModExpression",
			pos:  position{line: 597, col: 1, offset: 22138},
			expr: &actionExpr{
				pos: position{line: 597, col: 25, offset: 22162},
				run: (*parser).callonMathIntModExpression1,
				expr: &seqExpr{
					pos: position{line: 597, col: 25, offset: 22162},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 597, col: 25, offset: 22162},
							val:        "intmod",
							ignoreCase: true,
							want:       "\"IntMod\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 35, offset: 22172},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 38, offset: 22175},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 42, offset: 22179},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 597, col: 45, offset: 22182},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 597, col: 50, offset: 22187},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 61, offset: 22198},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 64, offset: 22201},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 68, offset: 22205},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 597, col: 71, offset: 22208},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 597, col: 76, offset: 22213},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 87, offset: 22224},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 90, offset: 22227},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntMulExpression",
			pos:  position{line: 598, col: 1, offset: 22320},
			expr: &actionExpr{
				pos: position{line: 598, col: 25, offset: 22344},
				run: (*parser).callonMathIntMulExpression1,
				expr: &seqExpr{
					pos: position{line: 598, col: 25, offset: 22344},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 598, col: 25, offset: 22344},
							val:        "intmul",
							ignoreCase: true,
							want:       "\"IntMul\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 35, offset: 22354},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 598, col: 38, offset: 22357},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 42, offset: 22361},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 598, col: 45, offset: 22364},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 598, col: 50, offset: 22369},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 61, offset: 22380},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 598, col: 64, offset: 22383},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 68, offset: 22387},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 598, col: 71, offset: 22390},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 598, col: 76, offset: 22395},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 598, col: 87, offset: 22406},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 598, col: 90, offset: 22409},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntSubExpression",
			pos:  position{line: 599, col: 1, offset: 22502},
			expr: &actionExpr{
				pos: position{line: 599, col: 25, offset: 22526},
				run: (*parser).callonMathIntSubExpression1,
				expr: &seqExpr{
					pos: position{line: 599, col: 25, offset: 22526},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 599, col: 25, offset: 22526},
							val:        "intsub",
							ignoreCase: true,
							want:       "\"IntSub\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 599, col: 35, offset: 22536},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 599, col: 38, offset: 22539},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 599, col: 42, offset: 22543},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 599, col: 45, offset: 22546},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 599, col: 50, offset: 22551},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 599, col: 61, offset: 22562},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 599, col: 64, offset: 22565},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 599, col: 68, offset: 22569},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 599, col: 71, offset: 22572},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 599, col: 76, offset: 22577},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 599, col: 87, offset: 22588},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 599, col: 90, offset: 22591},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPowerExpression",
			pos:  position{line: 600, col: 1, offset: 22684},
			expr: &actionExpr{
				pos: position{line: 600, col: 24, offset: 22707},
				run: (*parser).callonMathPowerExpression1,
				expr: &seqExpr{
					pos: position{line: 600, col: 24, offset: 22707},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 600, col: 24, offset: 22707},
							val:        "power",
							ignoreCase: true,
							want:       "\"POWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 33, offset: 22716},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 600, col: 36, offset: 22719},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 40, offset: 22723},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 600, col: 43, offset: 22726},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 600, col: 48, offset: 22731},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 59, offset: 22742},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 600, col: 62, offset: 22745},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 66, offset: 22749},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 600, col: 69, offset: 22752},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 600, col: 74, offset: 22757},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 85, offset: 22768},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 600, col: 88, offset: 22771},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLogExpression",
			pos:  position{line: 602, col: 1, offset: 22864},
			expr: &actionExpr{
				pos: position{line: 602, col: 22, offset: 22885},
				run: (*parser).callonMathLogExpression1,
				expr: &seqExpr{
					pos: position{line: 602, col: 22, offset: 22885},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 602, col: 22, offset: 22885},
							val:        "log",
							ignoreCase: true,
							want:       "\"LOG\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 602, col: 29, offset: 22892},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 602, col: 32, offset: 22895},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 602, col: 36, offset: 22899},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 602, col: 39, offset: 22902},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 602, col: 43, offset: 22906},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 602, col: 54, offset: 22917},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 602, col: 61, offset: 22924},
								expr: &actionExpr{
									pos: position{line: 602, col: 62, offset: 22925},
									run: (*parser).callonMathLogExpression11,
									expr: &seqExpr{
										pos: position{line: 602, col: 62, offset: 22925},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 602, col: 62, offset: 22925},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 602, col: 65, offset: 22928},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 602, col: 69, offset: 22932},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 602, col: 72, offset: 22935},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 602, col: 75, offset: 22938},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 602, col: 107, offset: 22970},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 602, col: 110, offset: 22973},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathNumberBinExpression",
			pos:  position{line: 605, col: 1, offset: 23095},
			expr: &actionExpr{
				pos: position{line: 605, col: 28, offset: 23122},
				run: (*parser).callonMathNumberBinExpression1,
				expr: &seqExpr{
					pos: position{line: 605, col: 28, offset: 23122},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 605, col: 28, offset: 23122},
							val:        "numberbin",
							ignoreCase: true,
							want:       "\"NumberBin\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 605, col: 41, offset: 23135},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 605, col: 44, offset: 23138},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 605, col: 48, offset: 23142},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 605, col: 51, offset: 23145},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 605, col: 55, offset: 23149},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 605, col: 66, offset: 23160},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 605, col: 73, offset: 23167},
								expr: &actionExpr{
									pos: position{line: 605, col: 74, offset: 23168},
									run: (*parser).callonMathNumberBinExpression11,
									expr: &seqExpr{
										pos: position{line: 605, col: 74, offset: 23168},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 605, col: 74, offset: 23168},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 605, col: 77, offset: 23171},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 605, col: 81, offset: 23175},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 605, col: 84, offset: 23178},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 605, col: 87, offset: 23181},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 605, col: 119, offset: 23213},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 605, col: 122, offset: 23216},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPiExpression",
			pos:  position{line: 608, col: 1, offset: 23344},
			expr: &actionExpr{
				pos: position{line: 608, col: 21, offset: 23364},
				run: (*parser).callonMathPiExpression1,
				expr: &seqExpr{
					pos: position{line: 608, col: 21, offset: 23364},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 608, col: 21, offset: 23364},
							val:        "pi",
							ignoreCase: true,
							want:       "\"PI\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 608, col: 27, offset: 23370},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 608, col: 30, offset: 23373},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 608, col: 34, offset: 23377},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 608, col: 37, offset: 23380},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRandExpression",
			pos:  position{line: 609, col: 1, offset: 23459},
			expr: &actionExpr{
				pos: position{line: 609, col: 23, offset: 23481},
				run: (*parser).callonMathRandExpression1,
				expr: &seqExpr{
					pos: position{line: 609, col: 23, offset: 23481},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 609, col: 23, offset: 23481},
							val:        "rand",
							ignoreCase: true,
							want:       "\"RAND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 31, offset: 23489},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 609, col: 34, offset: 23492},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 38, offset: 23496},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 609, col: 41, offset: 23499},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 611, col: 1, offset: 23581},
			expr: &actionExpr{
				pos: position{line: 611, col: 15, offset: 23595},
				run: (*parser).callonInFunction1,
				expr: &seqExpr{
					pos: position{line: 611, col: 15, offset: 23595},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 611, col: 15, offset: 23595},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 611, col: 19, offset: 23599},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 611, col: 34, offset: 23614},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 611, col: 37, offset: 23617},
							val:        "in",
							ignoreCase: true,
							want:       "\"IN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 611, col: 43, offset: 23623},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 611, col: 46, offset: 23626},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 611, col: 50, offset: 23630},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 611, col: 53, offset: 23633},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 611, col: 57, offset: 23637},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 611, col: 68, offset: 23648},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 611, col: 75, offset: 23655},
								expr: &actionExpr{
									pos: position{line: 611, col: 76, offset: 23656},
									run: (*parser).callonInFunction14,
									expr: &seqExpr{
										pos: position{line: 611, col: 76, offset: 23656},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 611, col: 76, offset: 23656},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 611, col: 79, offset: 23659},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 611, col: 83, offset: 23663},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 611, col: 86, offset: 23666},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 611, col: 89, offset: 23669},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 611, col: 121, offset: 23701},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 611, col: 124, offset: 23704},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "AvgAggregateExpression",
			pos:  position{line: 615, col: 1, offset: 23827},
			expr: &actionExpr{
				pos: position{line: 615, col: 29, offset: 23855},
				run: (*parser).callonAvgAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 615, col: 29, offset: 23855},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 615, col: 29, offset: 23855},
							val:        "avg",
							ignoreCase: true,
							want:       "\"AVG\"i",
						},
						&litMatcher{
							pos:        position{line: 615, col: 36, offset: 23862},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 615, col: 40, offset: 23866},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 615, col: 43, offset: 23869},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 615, col: 46, offset: 23872},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 615, col: 58, offset: 23884},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 615, col: 61, offset: 23887},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "CountAggregateExpression",
			pos:  position{line: 619, col: 1, offset: 23979},
			expr: &actionExpr{
				pos: position{line: 619, col: 29, offset: 24007},
				run: (*parser).callonCountAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 619, col: 29, offset: 24007},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 619, col: 29, offset: 24007},
							val:        "count",
							ignoreCase: true,
							want:       "\"COUNT\"i",
						},
						&litMatcher{
							pos:        position{line: 619, col: 38, offset: 24016},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 619, col: 42, offset: 24020},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 619, col: 45, offset: 24023},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 619, col: 48, offset: 24026},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 619, col: 59, offset: 24037},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 619, col: 62, offset: 24040},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MaxAggregateExpression",
			pos:  position{line: 623, col: 1, offset: 24134},
			expr: &actionExpr{
				pos: position{line: 623, col: 29, offset: 24162},
				run: (*parser).callonMaxAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 623, col: 29, offset: 24162},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 623, col: 29, offset: 24162},
							val:        "max",
							ignoreCase: true,
							want:       "\"MAX\"i",
						},
						&litMatcher{
							pos:        position{line: 623, col: 36, offset: 24169},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 623, col: 40, offset: 24173},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 623, col: 43, offset: 24176},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 623, col: 46, offset: 24179},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 623, col: 57, offset: 24190},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 623, col: 60, offset: 24193},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MinAggregateExpression",
			pos:  position{line: 627, col: 1, offset: 24285},
			expr: &actionExpr{
				pos: position{line: 627, col: 29, offset: 24313},
				run: (*parser).callonMinAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 627, col: 29, offset: 24313},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 627, col: 29, offset: 24313},
							val:        "min",
							ignoreCase: true,
							want:       "\"MIN\"i",
						},
						&litMatcher{
							pos:        position{line: 627, col: 36, offset: 24320},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 627, col: 40, offset: 24324},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 627, col: 43, offset: 24327},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 627, col: 46, offset: 24330},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 627, col: 57, offset: 24341},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 627, col: 60, offset: 24344},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SumAggregateExpression",
			pos:  position{line: 631, col: 1, offset: 24436},
			expr: &actionExpr{
				pos: position{line: 631, col: 29, offset: 24464},
				run: (*parser).callonSumAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 631, col: 29, offset: 24464},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 631, col: 29, offset: 24464},
							val:        "sum",
							ignoreCase: true,
							want:       "\"SUM\"i",
						},
						&litMatcher{
							pos:        position{line: 631, col: 36, offset: 24471},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 631, col: 40, offset: 24475},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 631, col: 43, offset: 24478},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 631, col: 46, offset: 24481},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 631, col: 57, offset: 24492},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 631, col: 60, offset: 24495},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 635, col: 1, offset: 24587},
			expr: &actionExpr{
				pos: position{line: 635, col: 12, offset: 24598},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 635, col: 12, offset: 24598},
					expr: &charClassMatcher{
						pos:        position{line: 635, col: 12, offset: 24598},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 639, col: 1, offset: 24650},
			expr: &choiceExpr{
				pos: position{line: 639, col: 20, offset: 24669},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 639, col: 20, offset: 24669},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 639, col: 20, offset: 24669},
							exprs: []any{
								&notExpr{
									pos: position{line: 639, col: 20, offset: 24669},
									expr: &choiceExpr{
										pos: position{line: 639, col: 22, offset: 24671},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 639, col: 22, offset: 24671},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 639, col: 28, offset: 24677},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 639, col: 34, offset: 24683,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 640, col: 5, offset: 24720},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 640, col: 5, offset: 24720},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 640, col: 5, offset: 24720},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 640, col: 10, offset: 24725},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 640, col: 14, offset: 24729},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 642, col: 1, offset: 24774},
			expr: &labeledExpr{
				pos:   position{line: 642, col: 28, offset: 24801},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 642, col: 33, offset: 24806},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 644, col: 1, offset: 24823},
			expr: &choiceExpr{
				pos: position{line: 644, col: 20, offset: 24842},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 644, col: 20, offset: 24842},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 645, col: 5, offset: 24850},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 646, col: 5, offset: 24858},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 647, col: 5, offset: 24867},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 647, col: 5, offset: 24867},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 648, col: 5, offset: 24896},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 648, col: 5, offset: 24896},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 649, col: 5, offset: 24925},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 649, col: 5, offset: 24925},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 650, col: 5, offset: 24954},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 650, col: 5, offset: 24954},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 651, col: 5, offset: 24983},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 651, col: 5, offset: 24983},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 653, col: 1, offset: 25009},
			expr: &actionExpr{
				pos: position{line: 653, col: 25, offset: 25033},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 653, col: 25, offset: 25033},
					exprs: []any{
						&notExpr{
							pos: position{line: 653, col: 25, offset: 25033},
							expr: &ruleRefExpr{
								pos:  position{line: 653, col: 27, offset: 25035},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 653, col: 45, offset: 25053},
							label: "char",
							expr: &anyMatcher{
								line: 653, col: 50, offset: 25058,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 656, col: 1, offset: 25097},
			expr: &zeroOrMoreExpr{
				pos: position{line: 656, col: 7, offset: 25103},
				expr: &charClassMatcher{
					pos:        position{line: 656, col: 7, offset: 25103},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 658, col: 1, offset: 25115},
			expr: &notExpr{
				pos: position{line: 658, col: 8, offset: 25122},
				expr: &anyMatcher{
					line: 658, col: 9, offset: 25123,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt23(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt23() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt23(stack["condition"])
}

func (c *current) onSelectStmt32(columns any) (any, error) {
	return columns, nil
}

func (p *parser) callonSelectStmt32() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt32(stack["columns"])
}

func (c *current) onSelectStmt1(distinctClause, topClause, columns, table, whereClause, groupByClause, orderByClause, offsetClause any) (any, error) {
	return makeSelectStmt(columns, table, whereClause,
		distinctClause, topClause, groupByClause, orderByClause, offsetClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["distinctClause"], stack["topClause"], stack["columns"], stack["table"], stack["whereClause"], stack["groupByClause"], stack["orderByClause"], stack["offsetClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onOffsetClause1(offset, limit any) (any, error) {
	return []interface{}{offset.(parsers.Constant).Value, limit.(parsers.Constant).Value}, nil
}

func (p *parser) callonOffsetClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOffsetClause1(stack["offset"], stack["limit"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject10(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject10(stack["coll"])
}

func (c *current) onSelectObject1(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject1(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItem1(selectItem, asClause any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	if aliasValue, ok := asClause.(string); ok {
		itemResult.Alias = aliasValue
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"], stack["asClause"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess2(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess2(stack["id"])
}

func (c *current) onArrayFieldAccess8(id any) (any, error) {
	return strconv.Itoa(id.(int)), nil
}

func (p *parser) callonArrayFieldAccess8() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess8(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["ex"])
}

func (c *current) onComparisonExpression23(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression23() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression23(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return createFunctionCall(functionType, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathAbsExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAbs, []interface{}{ex})
}

func (p *parser) callonMathAbsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAbsExpression1(stack["ex"])
}

func (c *current) onMathAcosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAcos, []interface{}{ex})
}

func (p *parser) callonMathAcosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAcosExpression1(stack["ex"])
}

func (c *current) onMathAsinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAsin, []interface{}{ex})
}

func (p *parser) callonMathAsinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAsinExpression1(stack["ex"])
}

func (c *current) onMathAtanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtan, []interface{}{ex})
}

func (p *parser) callonMathAtanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtanExpression1(stack["ex"])
}

func (c *current) onMathCeilingExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCeiling, []interface{}{ex})
}

func (p *parser) callonMathCeilingExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCeilingExpression1(stack["ex"])
}

func (c *current) onMathCosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCos, []interface{}{ex})
}

func (p *parser) callonMathCosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCosExpression1(stack["ex"])
}

func (c *current) onMathCotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCot, []interface{}{ex})
}

func (p *parser) callonMathCotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCotExpression1(stack["ex"])
}

func (c *current) onMathDegreesExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathDegrees, []interface{}{ex})
}

func (p *parser) callonMathDegreesExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathDegreesExpression1(stack["ex"])
}

func (c *current) onMathExpExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathExp, []interface{}{ex})
}

func (p *parser) callonMathExpExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathExpExpression1(stack["ex"])
}

func (c *current) onMathFloorExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathFloor, []interface{}{ex})
}

func (p *parser) callonMathFloorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathFloorExpression1(stack["ex"])
}

func (c *current) onMathIntBitNotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitNot, []interface{}{ex})
}

func (p *parser) callonMathIntBitNotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitNotExpression1(stack["ex"])
}

func (c *current) onMathLog10Expression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog10, []interface{}{ex})
}

func (p *parser) callonMathLog10Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLog10Expression1(stack["ex"])
}

func (c *current) onMathRadiansExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRadians, []interface{}{ex})
}

func (p *parser) callonMathRadiansExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRadiansExpression1(stack["ex"])
}

func (c *current) onMathRoundExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRound, []interface{}{ex})
}

func (p *parser) callonMathRoundExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRoundExpression1(stack["ex"])
}

func (c *current) onMathSignExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSign, []interface{}{ex})
}

func (p *parser) callonMathSignExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSignExpression1(stack["ex"])
}

func (c *current) onMathSinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSin, []interface{}{ex})
}

func (p *parser) callonMathSinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSinExpression1(stack["ex"])
}

func (c *current) onMathSqrtExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSqrt, []interface{}{ex})
}

func (p *parser) callonMathSqrtExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSqrtExpression1(stack["ex"])
}

func (c *current) onMathSquareExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSquare, []interface{}{ex})
}

func (p *parser) callonMathSquareExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSquareExpression1(stack["ex"])
}

func (c *current) onMathTanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTan, []interface{}{ex})
}

func (p *parser) callonMathTanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTanExpression1(stack["ex"])
}

func (c *current) onMathTruncExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTrunc, []interface{}{ex})
}

func (p *parser) callonMathTruncExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTruncExpression1(stack["ex"])
}

func (c *current) onMathAtn2Expression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtn2, []interface{}{set1, set2})
}

func (p *parser) callonMathAtn2Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtn2Expression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntAddExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntAdd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntAddExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntAddExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitAndExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitAnd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitAndExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitLeftShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitLeftShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitLeftShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitLeftShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitOrExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitOr, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitOrExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitRightShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitRightShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitRightShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitRightShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitXorExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitXor, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitXorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitXorExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntDivExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntDiv, []interface{}{set1, set2})
}

func (p *parser) callonMathIntDivExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntDivExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntModExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMod, []interface{}{set1, set2})
}

func (p *parser) callonMathIntModExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntModExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntMulExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMul, []interface{}{set1, set2})
}

func (p *parser) callonMathIntMulExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntMulExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntSubExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntSub, []interface{}{set1, set2})
}

func (p *parser) callonMathIntSubExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntSubExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathPowerExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPower, []interface{}{set1, set2})
}

func (p *parser) callonMathPowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPowerExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathLogExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathLogExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression11(stack["ex"])
}

func (c *current) onMathLogExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathLogExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathNumberBinExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathNumberBinExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression11(stack["ex"])
}

func (c *current) onMathNumberBinExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathNumberBin, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathNumberBinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathPiExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPi, []interface{}{})
}

func (p *parser) callonMathPiExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPiExpression1()
}

func (c *current) onMathRandExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRand, []interface{}{})
}

func (p *parser) callonMathRandExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRandExpression1()
}

func (c *current) onInFunction14(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction14(stack["ex"])
}

func (c *current) onInFunction1(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction1(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onAvgAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateAvg, []interface{}{ex})
}

func (p *parser) callonAvgAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAvgAggregateExpression1(stack["ex"])
}

func (c *current) onCountAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateCount, []interface{}{ex})
}

func (p *parser) callonCountAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCountAggregateExpression1(stack["ex"])
}

func (c *current) onMaxAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMax, []interface{}{ex})
}

func (p *parser) callonMaxAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMaxAggregateExpression1(stack["ex"])
}

func (c *current) onMinAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMin, []interface{}{ex})
}

func (p *parser) callonMinAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMinAggregateExpression1(stack["ex"])
}

func (c *current) onSumAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateSum, []interface{}{ex})
}

func (p *parser) callonSumAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSumAggregateExpression1(stack["ex"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expresssions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
